package benchmark.nqueen.gui;

import static util.parser.InstanceTokens.EXTENSION;
import static util.parser.InstanceTokens.INTENSION;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.io.File;

import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;

import benchmark.nqueen.NQueenGenerator;
import gui.generators.Generator;

import javax.swing.JComboBox;

public class NQueenGeneratorPanel extends Generator {

	public static final long serialVersionUID = 1L;
	public JLabel minLabel = null;
	public JLabel maxLabel = null;
	public JLabel stepLabel = null;
	public JSpinner min = null;
	public JSpinner max = null;
	public JTextField step = null;
	private JLabel ConstraintType = null;
	JSpinner stepSpinner = null;
	private JPanel principalPanel = null;
	private JComboBox types = null;

	/**
	 * This is the default constructor
	 */
	public NQueenGeneratorPanel() {
		super();
		this.add(this.getPrincipalPanel(), BorderLayout.CENTER);
	}

	protected JPanel getPrincipalPanel() {
		if (principalPanel == null) {
			principalPanel = new JPanel(null);
			ConstraintType = new JLabel("Type of constraints", JLabel.CENTER);
			ConstraintType.setBounds(new Rectangle(175, 20, 150, 22));
			minLabel = new JLabel("Minimum Queens", JLabel.RIGHT);
			minLabel.setBounds(new Rectangle(125, 100, 150, 22));
			maxLabel = new JLabel("Maximum Queens", JLabel.RIGHT);
			maxLabel.setBounds(new Rectangle(125, 160, 150, 22));
			stepLabel = new JLabel("Step", JLabel.RIGHT);
			stepLabel.setBounds(new Rectangle(125, 220, 150, 22));
			principalPanel.setPreferredSize(new Dimension(500, 400));
			principalPanel.setMinimumSize(new Dimension(500, 400));
			principalPanel.add(getMin(), null);
			principalPanel.add(minLabel, null);
			principalPanel.add(getMax(), null);
			principalPanel.add(maxLabel, null);
			principalPanel.add(stepLabel, null);
			principalPanel.add(getStep(), null);
			principalPanel.add(ConstraintType, null);
			principalPanel.add(getTypes(), null);  // Generated
			principalPanel.add(getMax(), null);
		}
		return principalPanel;
	}
	
	public JComboBox getTypes(){
		if(types == null){
			String[] type = {EXTENSION, INTENSION};
			types = new JComboBox(type);
			types.setBounds(new Rectangle(175, 50, 150, 24));  // Generated
		}
		return types;
	}

	/**
	 * This method initializes min
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getMin() {
		if (min == null) {
			min = new JSpinner(new SpinnerNumberModel(10, 4, 500, 1));
			min.setBounds(new Rectangle(280, 100, 60, 22));
		}
		return min;
	}

	/**
	 * This method initializes max
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getMax() {
		if (max == null) {
			max = new JSpinner(new SpinnerNumberModel(15, 4, 1000, 1));
			max.setBounds(new Rectangle(280, 160, 60, 22));
		}
		return max;
	}

	/**
	 * This method initializes step
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getStep() {
		if (stepSpinner == null) {
			stepSpinner = new JSpinner(new SpinnerNumberModel(1, 1, 500, 1));
			stepSpinner.setBounds(new Rectangle(280, 220, 60, 22));
		}
		return stepSpinner;
	}

	public void generate(File file) {
		int min = (Integer) (getMin().getValue());
		int max = (Integer) (getMax().getValue());
		int step = (Integer) getStep().getValue();
		if (min > max) {
			String error = min > max? "The min must be less or equal the max" : "";
			JOptionPane.showMessageDialog(this, "Set parameters correctly\n" + error, "DisChoco", JOptionPane.WARNING_MESSAGE);
			return;
		}
		NQueenGenerator nQueen = new NQueenGenerator(file, min, max, step);
		nQueen.setType((String) getTypes().getSelectedItem());
		nQueen.generate();
		file = null;
		JOptionPane.showMessageDialog(this, "Problems was generated with success");
		return;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
