package gui;

import simulation.DisSolverSimulator;

/**
 * @authors <a href="mailto:ezzahir@ensa-agadir.ac.ma?subject=DisChoco &cc=wahbi@lirmm.fr &cc=bessiere@lirmm.fr"> Redoaune Ezzahir</a> and <a
 *          href="mailto:wahbi@lirmm.fr?subject=DisChoco &cc=ezzahir@ensa-agadir.ac.ma &cc=bessiere@lirmm.fr"> Mohamed Wahbi</a>
 * 
 */
public abstract class GuiSimulator {

	private static final long serialVersionUID = -5108038341740467250L;
	public DisSolverSimulator solver = null;
	public boolean stop = false;
	public boolean isRunning = false;

	/**
	 * 
	 */
	public GuiSimulator() {}

	public abstract void lunch();

	public void pause() {
		this.solver.suspendThreads();
	}
	
	public void resume() {
		if(solver == null){
			resumeWithoutSolver();
		} else {
			this.solver.resumeThreads();
		}
	}
	
	/**
	 * 
	 */
	public abstract void resumeWithoutSolver();

	public void stop() {
		this.solver.stoptRunning();
		this.solver.stopThreads();
	}

}


