package simple.dcsp.abtfamily.abtdac;

import kernel.AbstractAgent;
import kernel.StopException;
import kernel.com.Message;
import kernel.com.MessageHandler;
import util.Commands;
import util.IntArray;
import util.VarAssignment;

public class OkMessageHandler extends MessageHandler {

	public OkMessageHandler(AbstractAgent agent) {
		super(agent, Commands.OK);
	}

	@Override
	public void processMessage(Message msg) throws StopException {
		VarAssignment senderAss = (VarAssignment) msg.get(Commands.OK);
		if (this.myAgent.agentView.compareTimeCounter(senderAss) >= 0) {
			this.myAgent.agentView.priorityMerge(senderAss);
			((ABTdacAgent) this.myAgent).checkAgentView();
		} else {
			this.myAgent.auxiliaryStatistics.get(Commands.ObsoleteOk).value++;
		}
	}

	public void sendOkMessages() {
		IntArray lowerNeighbors = this.myAgent.communicator.getLowerNeighbors();
		for (int i = 0 ; i < lowerNeighbors.size() ; i++) {
			this.sendOkMessage(lowerNeighbors.get(i));
		}
	}

	/**
	 * 
	 */
	public void sendOkMessage(int receiverId) {
		VarAssignment myVarAss = ((ABTdacAgent) this.myAgent).var.getVarAssignment();
		Message msg = this.createMessage();
		msg.addContents(Commands.OK, myVarAss);
		msg.setReceiverId(receiverId);
		this.myAgent.sendMessage(msg);
	}

}
