/*************************************************************************

 **************************************************************************/

package simple.dcsp.agileabt.explanation;

import kernel.StopException;
import kernel.com.Message;
import kernel.com.MessageHandler;
import util.Commands;
import util.IntArray;
import util.Tools;
import util.VarAssignment;

public class OkMsgHandler extends MessageHandler {

	public OkMsgHandler(AgileABTAgent agent) {
		super(agent, Commands.OK);
	}

	/**
	 * @param msg
	 */
	public void processMessage(Message msg) throws StopException {
		VarAssignment ass = (VarAssignment) msg.get(Commands.OK);
		IntArray order = IntArray.fromString("" + msg.get(Commands.ORDER));
		double[] TV = Tools.DoubleArrayFromString("" + msg.get(AgileABTAgent.TV));
		((AgileABTAgent) this.myAgent).checkOrder(order, TV);
		Explanation exp = (Explanation) msg.get(AgileABTAgent.Explanation);
		((AgileABTAgent) this.myAgent).updateAgentView(exp.getLhs(), ass);
		((AgileABTAgent) this.myAgent).updateExplanation(msg.getSenderId(), exp);
		((AgileABTAgent) this.myAgent).CheckAgentView();
	}

	/**
	 * 
	 */
	public void sendOkMessages() {
		Explanation explanation = ((AgileABTAgent) this.myAgent).getMyExplanation();
		IntArray receivers = null;
		if (((AgileABTAgent) this.myAgent).onlyToNeighbors) {
			receivers = this.myAgent.communicator.getLowerNeighbors();
		} else {
			receivers = this.myAgent.agentOrder.getLowerAgents();
		}
		for (int lower : receivers) {
			this.sendOkMessage(lower, explanation);
		}
		((AgileABTAgent) this.myAgent).IchangeMyOrder = false;
	}

	/**
	 * 
	 * @param neig
	 * @param myExp
	 */
	public void sendOkMessage(int neig, Explanation myExp) {
		IntArray myOrder = this.myAgent.getOrder();
		String myTV = Tools.arrayToString(((AgileABTAgent) this.myAgent).myTV);
		Message msg = this.createMessage();
		msg.addContents(Commands.OK, ((AgileABTAgent) this.myAgent).var.getVarAssignment());
		msg.addContents(AgileABTAgent.Explanation, myExp);
		msg.addContents(Commands.ORDER, myOrder.toString());
		msg.addContents(AgileABTAgent.TV, myTV);
		msg.setReceiverId(neig);
		((AgileABTAgent) this.myAgent).storeStatisticsFor(msg);
		this.myAgent.sendMessage(msg);
	}

}
