package util;

import java.lang.reflect.Method;

public class ParameterTypes {

	public static int StringType = -1;
	public static int BooleanType = 0;
	public static int CharType = 1;
	public static int ShortType = 2;
	public static int IntType = 3;
	public static int LongType = 4;
	public static int FloatType = 5;
	public static int DoubleType = 6;
	public static int ObjectType = 7;

	public ParameterTypes() {
		super();
	}

	public static boolean isBoolean(String s) {
		return s.equals("true") || s.equals("false");
	}

	public static boolean isChar(String s) {
		return (s.length() == 1 && !isInt(s));
	}

	public static boolean isInt(String str) {
		if (str.length() > 0 && str.charAt(0) != '+' && str.charAt(0) != '-' && !(str.charAt(0) >= '0' && str.charAt(0) <= '9'))
			return false;
		for (int i = 1 ; i < str.length() ; i++) {
			char ch = str.charAt(i);
			if (ch < '0' || ch > '9')
				return false;
		}
		return true;
	}

	public static boolean isFloat(String str) {
		int pos = 0;
		if (pos < str.length() && (str.charAt(pos) == '+' || str.charAt(pos) == '-'))
			pos++;
		while (pos < str.length() && (str.charAt(pos) >= '0' && str.charAt(pos) <= '9'))
			pos++;
		if (pos < str.length() && str.charAt(pos) == '.')
			pos++;
		while (pos < str.length() && (str.charAt(pos) >= '0' && str.charAt(pos) <= '9'))
			pos++;
		if (pos < str.length() && (str.charAt(pos) == 'e' || str.charAt(pos) == 'E'))
			pos++;
		if (pos < str.length() && (str.charAt(pos) == '+' || str.charAt(pos) == '-'))
			pos++;
		while (pos < str.length() && (str.charAt(pos) >= '0' && str.charAt(pos) <= '9'))
			pos++;
		return (pos == str.length());
	}

	public void methode(boolean b, char c, short s, int i, long l, float f, double d) {}

	@SuppressWarnings("unchecked")
	public static Class[] getParameterTypes(int[] types) {

		Class c = (new ParameterTypes()).getClass();
		Class[] paraTypes = null;

		Method[] m = c.getDeclaredMethods();
		Method meth = null;
		for (int k = 0 ; k < m.length ; k++)
			if (m[k].getName().equals("methode"))
				meth = m[k];

		if (meth != null)
			paraTypes = meth.getParameterTypes();

		Class[] result = new Class[types.length];

		for (int k = 0 ; k < types.length ; k++) {
			if (StringType < types[k] && types[k] < ObjectType)
				result[k] = paraTypes[types[k]];
			else
				result[k] = null;
		}

		return result;
	}

	@SuppressWarnings("unchecked")
	public static void main(String arg[]) {
		int[] x = {0, 2, 3, 5};

		Class[] parameterTypes = ParameterTypes.getParameterTypes(x);
		for (int k = 0 ; k < parameterTypes.length ; k++) {
			String parameterString = parameterTypes[k].getName();
			System.out.print(parameterString + " ");
		}

	}

}
